--[[
	Druid Cast

	By java aka Express/Toaster

	Es hat mich angekotzt, dass man z.B. versehentlich nicht-Manaklassen
	innervaten kann und Macros spammt, wenn man ein Ziel nicht ressen kann.
]]


function DruidCast_OnLoad()

	DEFAULT_CHAT_FRAME:AddMessage(DC_LOADING_MSG);

	SLASH_DruidCast1 = "/DruidCast";
	SLASH_DruidCast2 = "/dc";
	SlashCmdList["DruidCast"] = function(msg)
		DruidCast_SlashCommandHandler(msg);
	end
end


-- Funktion zum Testen auf Cooldown, kopiert von WhisperCast
local function DruidCast_CheckCooldown(spell)
	local i,done,name,id=1,false;
	while (not done) do
		local name = GetSpellName(i,BOOKTYPE_SPELL);
		local start, duration, enable = GetSpellCooldown(i, BOOKTYPE_SPELL);
		restzeit = (start+duration) - GetTime();
		if(restzeit<0)
		then
			restzeit = 0;
		end

		if(IsAddOnLoaded("CT_RaidAssist"))
		then
			CTrestzeit = CT_RA_FormatTime(restzeit);
		else
			CTrestzeit = restzeit;
		end

		if (not name) then
			done=true;
		elseif (name == spell) then
			if ( start > 0 and duration > 0 and enable > 0) then
				-- Cooldown left
				return true;
			else
				-- There should be no cooldown
				return false;
			end
		end
		i = i+1;
	end
end


function DruidCast_CheckShapeshift(spell)

	for i=1, GetNumShapeshiftForms()
	do
		local i,n,a,c = GetShapeshiftFormInfo(i);
	
		if(n == spell and a == true)
		then
			return true;

		else
			return false;
		end

	end

end


function DruidCast_SlashCommandHandler(msg)

	-- Mana Prozentwert ausrechnen
	local DC_MANA = UnitMana("target");
	local DC_MANA_MAX = UnitManaMax("target");
	local DC_MANA_PERCENT = (DC_MANA*100)/DC_MANA_MAX;
	local DC_LEVEL = UnitLevel("target");

	if (string.lower(msg) == "battleress")
	then
		if(UnitIsDeadOrGhost("target") and not UnitIsDeadOrGhost("player") and UnitExists("target") and UnitIsFriend("player","target") and UnitIsPlayer("target") and DruidCast_CheckCooldown(DC_SPELL_REBIRTH) == false and UnitMana("player")>=1057 and DruidCast_CheckShapeshift(DC_TRAVEL_FORM)==false) 
		then 
			local ziel = UnitName("target");
			CastSpellByName(DC_SPELL_REBIRTH);

			if(IsAddOnLoaded("CT_RABossMods"))
			then
				CT_RABoss_Announce( "*** " .. DC_RESS_MSG .. " " .. ziel .. " ***", false);
				PlaySoundFile("Sound\\Doodad\\BellTollAlliance.wav");
				CT_RABoss_Schedule("DruidCast_OnEvent", 1800, "RessMSG");
				CT_RABoss_VisualTimer.addTimer("Rebirth", 1800, DC_SPELL_REBIRTH);
			end

			if(DC_RESS_CHAN ~= "SAY" and DC_RESS_CHAN ~= "RAID" and DC_RESS_CHAN ~= "GUILD" and DC_RESS_CHAN ~= "YELL")
			then
				SendChatMessage("<Druid Cast> " .. DC_RESS_MSG .. " " .. UnitName("target") .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
			else
				SendChatMessage("<Druid Cast> " .. DC_RESS_MSG .. " " .. UnitName("target") .. "!", DC_RESS_CHAN, GetDefaultLanguage("player"));
			end

			SendChatMessage("<Druid Cast> " .. DC_REBIRTH_MSG .. "!", "WHISPER", GetDefaultLanguage("player"), UnitName("target"));				

		elseif(DruidCast_CheckCooldown(DC_SPELL_REBIRTH) == true)
		then		
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_SPELL_REBIRTH .. " " .. DC_ONCOOLDOWN .. " (" .. CTrestzeit ..") !");

		elseif(UnitMana("player") < 1057)
		then
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_IS_OOM .. "!");

		elseif(DruidCast_CheckShapeshift(DC_TRAVEL_FORM)==true)
		then
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_IS_SHAPESHIFTED .. "!");

		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET3 .. "!");
		end


	elseif (string.lower(msg) == "innervate")
	then
		if(DC_SELF_CAST == 1 and not UnitExists("target") or DC_SELF_CAST == 1 and UnitIsEnemy("target","player"))
		then
			SpellTargetUnit("player");
			TargetUnit("player");
		end

		if(not UnitIsDeadOrGhost("target") and not UnitIsDeadOrGhost("player") and UnitIsFriend("player","target") and UnitIsPlayer("target") and UnitClass("target") ~= DC_CLASS_WARRIOR and UnitClass("target") ~= DC_CLASS_ROGUE and UnitClass("target") ~= DC_CLASS_WARLOCK and DC_MANA_PERCENT < DC_MANA_CHECK and DC_LEVEL >= 10 and DruidCast_CheckCooldown(DC_SPELL_INNERVATE) == false and UnitMana("player") >= 62 and DruidCast_CheckShapeshift(DC_TRAVEL_FORM)==false)
		then
			local ziel = UnitName("target");
			CastSpellByName(DC_SPELL_INNERVATE);

			if(UnitName("target") ~= UnitName("player"))
			then
				SendChatMessage("<Druid Cast> " .. DC_INNERVATE_MSG2 .. "!", "WHISPER", GetDefaultLanguage("player"), UnitName("target"));
			end

			if(IsAddOnLoaded("CT_RABossMods"))
				then
					CT_RABoss_Announce( "*** " .. DC_INNERVATE_MSG .. " " .. ziel .. " ***", false);
					PlaySoundFile("Sound\\Doodad\\BellTollAlliance.wav");
					CT_RABoss_Schedule("DruidCast_OnEvent", 360, "InnervateMSG");
					CT_RABoss_VisualTimer.addTimer("Innervate", 360, DC_SPELL_INNERVATE);
				end

			if(DC_RESS_CHAN ~= "SAY" and DC_RESS_CHAN ~= "RAID" and DC_RESS_CHAN ~= "GUILD" and DC_RESS_CHAN ~= "YELL")
			then
				SendChatMessage("<Druid Cast> *** " .. DC_INNERVATE_MSG .. " " .. ziel .. " ***", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
			else
				SendChatMessage("<Druid Cast> *** " .. DC_INNERVATE_MSG .. " " .. ziel .. " ***", DC_RESS_CHAN, GetDefaultLanguage("player"));
			end

			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_INNERVATE_MSG .. " " .. UnitName("target") .. "!");

		elseif(DruidCast_CheckCooldown(DC_SPELL_INNERVATE) == true)
		then		
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_SPELL_INNERVATE .. " " .. DC_ONCOOLDOWN .. " (" .. CTrestzeit ..") !");

		elseif(UnitMana("player") < 62)
		then
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_IS_OOM .. "!");

		elseif(DruidCast_CheckShapeshift("Travel Form")==true)
		then
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_IS_SHAPESHIFTED .. "!");
		
		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_INVALID_TARGET .."! " .. DC_INVALID_TARGET2 .. "!");
		end



	
	elseif (string.lower(msg) == "reju")
	then
		if(DC_SELF_CAST == 1 and not UnitExists("target") or DC_SELF_CAST == 1 and UnitIsEnemy("target","player"))
		then
			SpellTargetUnit("player");
			TargetUnit("player");
		end

		if (not UnitIsDeadOrGhost("target") and not UnitIsDeadOrGhost("player") and not UnitIsEnemy("target","player"))
		then
			for i=1,16
			do
				local texture = UnitBuff("target",i); 
				
				if texture ~= nil
				then
					if string.find(string.lower(texture),"rejuvenation")
					then
						if(DC_CAST_SWIFTMEND==1)
						then
							CastSpellByName(DC_SPELL_SWIFTMEND);
						else
							local ziel = UnitName("target");
							DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. ziel .." " .. DC_INVALID_TARGET4 .. " " .. DC_SPELL_REJU .. "!");
						end
						return end
					else
						break
				end
			end

			CastSpellByName(DC_SPELL_REJU);
		end



	elseif (string.lower(msg) == "cooldown" and IsAddOnLoaded("CT_RaidAssist"))
	then
		if(DruidCast_CheckCooldown(DC_SPELL_REBIRTH) == false)
		then
			SendChatMessage("<Druid Cast> " .. DC_SPELL_REBIRTH .. " ".. DC_ISREADY .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		else
			SendChatMessage("<Druid Cast> " .. DC_COOLDOWN .. " of " .. DC_SPELL_REBIRTH .. ": " .. CTrestzeit, "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		end


		if(DruidCast_CheckCooldown(DC_SPELL_INNERVATE) == false)
		then
			SendChatMessage("<Druid Cast> " .. DC_SPELL_INNERVATE .. " " .. DC_ISREADY .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		else
			SendChatMessage("<Druid Cast> " .. DC_COOLDOWN .. " of " .. DC_SPELL_INNERVATE .. ": " .. CTrestzeit, "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		end


	elseif (string.lower(msg) == "icooldown" and IsAddOnLoaded("CT_RaidAssist"))
	then
		if(DruidCast_CheckCooldown(DC_SPELL_REBIRTH) == false)
		then
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_SPELL_REBIRTH .. " ".. DC_ISREADY .. "!");
		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_COOLDOWN .. " of " .. DC_SPELL_REBIRTH .. ": " .. CTrestzeit);
		end


		if(DruidCast_CheckCooldown(DC_SPELL_INNERVATE) == false)
		then
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_SPELL_INNERVATE .. " " .. DC_ISREADY .. "!");
		else
			DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_COOLDOWN .. " of " .. DC_SPELL_INNERVATE .. ": " .. CTrestzeit);
		end

	else
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> ".. DC_HELP_MSG .. ":");
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> /dc battleress  /dc innervate  /dc reju  /dc cooldown  /dc icooldown");
	end
end	


function DruidCast_OnEvent(event)

	if ( event == "InnervateMSG" and IsAddOnLoaded("CT_RABossMods") )
	then
		PlaySoundFile("Sound\\Doodad\\BellTollAlliance.wav");
		CT_RABoss_Announce("*** " .. DC_SPELL_INNERVATE .. " " .. DC_ISREADY .. " ***", false);
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_SPELL_INNERVATE .. " " .. DC_ISREADY .. "!");

		if(DC_RESS_CHAN ~= "SAY" and DC_RESS_CHAN ~= "RAID" and DC_RESS_CHAN ~= "GUILD" and DC_RESS_CHAN ~= "YELL")
		then
			SendChatMessage("<Druid Cast> " .. DC_SPELL_INNERVATE .. " " .. DC_ISREADY .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		else
			SendChatMessage("<Druid Cast> " .. DC_SPELL_INNERVATE .. " " .. DC_ISREADY .. "!", DC_RESS_CHAN, GetDefaultLanguage("player"));
		end

	elseif ( event == "RessMSG" and IsAddOnLoaded("CT_RABossMods") )
	then
		PlaySoundFile("Sound\\Doodad\\BellTollAlliance.wav");
		CT_RABoss_Announce("*** " .. DC_SPELL_REBIRTH .. " " .. DC_ISREADY .. " ***", false);
		DEFAULT_CHAT_FRAME:AddMessage("<Druid Cast> " .. DC_SPELL_REBIRTH .. " " .. DC_ISREADY .. "!");
		if(DC_RESS_CHAN ~= "SAY" and DC_RESS_CHAN ~= "RAID" and DC_RESS_CHAN ~= "GUILD" and DC_RESS_CHAN ~= "YELL")
		then
			SendChatMessage("<Druid Cast> " .. DC_SPELL_REBIRTH .. " " .. DC_ISREADY .. "!", "CHANNEL", GetDefaultLanguage("player"), DC_RESS_CHAN);
		else
			SendChatMessage("<Druid Cast> " .. DC_SPELL_REBIRTH .. " " .. DC_ISREADY .. "!", DC_RESS_CHAN, GetDefaultLanguage("player"));
		end
	end
end